
/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */

static const char* const SdpTestCopy_cxx_Version =
    "$Id: SdpTestCopy.cxx,v 1.5 2000/12/18 23:44:54 bko Exp $";


#include "SdpSession.hxx"
#include <string>

void
copyTest()
{
    string sdp;
    sdp = "v=0\r\n";
    sdp += "o=mhandley 28908 23456 IN IP4 126.16.64.4\r\n";
    sdp += "s=SDP seminar\r\n";
    sdp += "i=information\r\n";
    sdp += "c=IN IP4 224.2.17.12/127\r\n";
    sdp += "t=1234567890 0\r\n";
    sdp += "a=recvonly\r\n";

    sdp += "m=audio 49230 RTP/AVP 96 97 98\r\n";
    sdp += "a=rtpmap:96 L8/8000\r\n";
    sdp += "a=rtpmap:97 L16/8000\r\n";
    sdp += "a=rtpmap:98 X-myrtpmap/8000\r\n";
    sdp += "c=IN IP4 128.2.124.5\r\n";

    sdp += "m=video 51372 RTP/AVP 31\r\n";
    sdp += "a=orient:portrait\r\n";
    sdp += "a=X-myAttrib:myValue\r\n";
    sdp += "a=ptime:100\r\n";
    sdp += "b=AS:64\r\n";

    SdpSession sdpDesc;
    sdpDesc.decode(sdp);

    SdpSession x;
    x = sdpDesc;
    if (x.encode() != sdpDesc.encode())
    {
        // error
        assert(0);
    }

    SdpSession y(x);

    if (x.encode() != y.encode())
    {
        assert(0);
    }

}


int
main()
{
    copyTest();
    return 0;
}
